Merge branch 'maint'
[git/git.git] / git-bisect.sh
CommitLineData
8cc6a083 1#!/bin/sh
d025524d 2
243a60fb
CC
3USAGE='[help|start|bad|good|skip|next|reset|visualize|replay|log|run]'
4LONG_USAGE='git bisect help
5 print this long help message.
6git bisect start [<bad> [<good>...]] [--] [<pathspec>...]
38a47fd6
CC
7 reset bisect state and start bisection.
8git bisect bad [<rev>]
9 mark <rev> a known-bad revision.
10git bisect good [<rev>...]
11 mark <rev>... known-good revisions.
5413812f 12git bisect skip [(<rev>|<range>)...]
6ca8b977 13 mark <rev>... untestable revisions.
38a47fd6
CC
14git bisect next
15 find next bisection to test and check it out.
6b87ce23
AK
16git bisect reset [<commit>]
17 finish bisection search and go back to commit.
38a47fd6
CC
18git bisect visualize
19 show bisect status in gitk.
20git bisect replay <logfile>
21 replay bisection log.
22git bisect log
23 show bisect log.
24git bisect run <cmd>...
243a60fb
CC
25 use <cmd>... to automatically bisect.
26
27Please use "git help bisect" to get the full man page.'
d025524d 28
8f321a39 29OPTIONS_SPEC=
ae2b0f15 30. git-sh-setup
4c550686 31require_work_tree
8cc6a083 32
ce32660e
JS
33_x40='[0-9a-f][0-9a-f][0-9a-f][0-9a-f][0-9a-f]'
34_x40="$_x40$_x40$_x40$_x40$_x40$_x40$_x40$_x40"
35
8cc6a083 36bisect_autostart() {
823ea121 37 test -s "$GIT_DIR/BISECT_START" || {
8cc6a083
LT
38 echo >&2 'You need to start by "git bisect start"'
39 if test -t 0
40 then
41 echo >&2 -n 'Do you want me to do it for you [Y/n]? '
42 read yesno
43 case "$yesno" in
44 [Nn]*)
45 exit ;;
46 esac
47 bisect_start
48 else
49 exit 1
50 fi
51 }
52}
53
54bisect_start() {
8cc6a083 55 #
634f2464 56 # Verify HEAD.
8cc6a083 57 #
48949a18 58 head=$(GIT_DIR="$GIT_DIR" git symbolic-ref -q HEAD) ||
ce32660e
JS
59 head=$(GIT_DIR="$GIT_DIR" git rev-parse --verify HEAD) ||
60 die "Bad HEAD - I need a HEAD"
634f2464 61
ee831f7d 62 #
634f2464 63 # Check if we are bisecting.
ee831f7d 64 #
d3e54c88 65 start_head=''
634f2464
CC
66 if test -s "$GIT_DIR/BISECT_START"
67 then
68 # Reset to the rev from where we started.
9d0cd91c 69 start_head=$(cat "$GIT_DIR/BISECT_START")
f3a186ff 70 git checkout "$start_head" -- || exit
634f2464
CC
71 else
72 # Get rev from where we start.
73 case "$head" in
74 refs/heads/*|$_x40)
75 # This error message should only be triggered by
76 # cogito usage, and cogito users should understand
77 # it relates to cg-seek.
78 [ -s "$GIT_DIR/head-name" ] &&
79 die "won't bisect on seeked tree"
80 start_head="${head#refs/heads/}"
81 ;;
82 *)
83 die "Bad HEAD - strange symbolic ref"
84 ;;
85 esac
86 fi
8cc6a083
LT
87
88 #
634f2464 89 # Get rid of any old bisect state.
8cc6a083 90 #
823ea121 91 bisect_clean_state || exit
38a47fd6
CC
92
93 #
94 # Check for one bad and then some good revisions.
95 #
96 has_double_dash=0
97 for arg; do
98 case "$arg" in --) has_double_dash=1; break ;; esac
99 done
de52f5a8 100 orig_args=$(git rev-parse --sq-quote "$@")
38a47fd6 101 bad_seen=0
d3e54c88 102 eval=''
38a47fd6
CC
103 while [ $# -gt 0 ]; do
104 arg="$1"
105 case "$arg" in
106 --)
8fe26f44 107 shift
38a47fd6
CC
108 break
109 ;;
110 *)
634f2464 111 rev=$(git rev-parse -q --verify "$arg^{commit}") || {
38a47fd6
CC
112 test $has_double_dash -eq 1 &&
113 die "'$arg' does not appear to be a valid revision"
114 break
115 }
737c74ee
CC
116 case $bad_seen in
117 0) state='bad' ; bad_seen=1 ;;
118 *) state='good' ;;
119 esac
d3e54c88 120 eval="$eval bisect_write '$state' '$rev' 'nolog'; "
8fe26f44 121 shift
38a47fd6
CC
122 ;;
123 esac
8fe26f44 124 done
38a47fd6 125
ba963de8
CC
126 #
127 # Change state.
128 # In case of mistaken revs or checkout error, or signals received,
129 # "bisect_auto_next" below may exit or misbehave.
130 # We have to trap this to be able to clean up using
131 # "bisect_clean_state".
132 #
133 trap 'bisect_clean_state' 0
134 trap 'exit 255' 1 2 3 15
135
136 #
137 # Write new start state.
138 #
ba963de8 139 echo "$start_head" >"$GIT_DIR/BISECT_START" &&
de52f5a8 140 git rev-parse --sq-quote "$@" >"$GIT_DIR/BISECT_NAMES" &&
ba963de8 141 eval "$eval" &&
6c98c054 142 echo "git bisect start$orig_args" >>"$GIT_DIR/BISECT_LOG" || exit
ba963de8
CC
143 #
144 # Check if we can proceed to the next bisect state.
145 #
38a47fd6 146 bisect_auto_next
ba963de8
CC
147
148 trap '-' 0
8cc6a083
LT
149}
150
55624f9a
CC
151bisect_write() {
152 state="$1"
153 rev="$2"
737c74ee 154 nolog="$3"
55624f9a
CC
155 case "$state" in
156 bad) tag="$state" ;;
157 good|skip) tag="$state"-"$rev" ;;
158 *) die "Bad bisect_write argument: $state" ;;
159 esac
ba963de8 160 git update-ref "refs/bisect/$tag" "$rev" || exit
f454cdc4 161 echo "# $state: $(git show-branch $rev)" >>"$GIT_DIR/BISECT_LOG"
6c98c054 162 test -n "$nolog" || echo "git bisect $state $rev" >>"$GIT_DIR/BISECT_LOG"
55624f9a
CC
163}
164
c9c4e2d5
CC
165is_expected_rev() {
166 test -f "$GIT_DIR/BISECT_EXPECTED_REV" &&
167 test "$1" = $(cat "$GIT_DIR/BISECT_EXPECTED_REV")
168}
169
c9c4e2d5
CC
170check_expected_revs() {
171 for _rev in "$@"; do
172 if ! is_expected_rev "$_rev"; then
173 rm -f "$GIT_DIR/BISECT_ANCESTORS_OK"
174 rm -f "$GIT_DIR/BISECT_EXPECTED_REV"
175 return
176 fi
177 done
178}
179
ee2314f5
CC
180bisect_skip() {
181 all=''
182 for arg in "$@"
183 do
184 case "$arg" in
185 *..*)
186 revs=$(git rev-list "$arg") || die "Bad rev input: $arg" ;;
187 *)
de52f5a8 188 revs=$(git rev-parse --sq-quote "$arg") ;;
ee2314f5
CC
189 esac
190 all="$all $revs"
191 done
1a66a489 192 eval bisect_state 'skip' $all
ee2314f5
CC
193}
194
155fc795 195bisect_state() {
8cc6a083 196 bisect_autostart
155fc795
CC
197 state=$1
198 case "$#,$state" in
199 0,*)
200 die "Please call 'bisect_state' with at least one argument." ;;
201 1,bad|1,good|1,skip)
202 rev=$(git rev-parse --verify HEAD) ||
203 die "Bad rev input: HEAD"
c9c4e2d5
CC
204 bisect_write "$state" "$rev"
205 check_expected_revs "$rev" ;;
e3389075 206 2,bad|*,good|*,skip)
155fc795 207 shift
d3e54c88 208 eval=''
e3389075 209 for rev in "$@"
155fc795 210 do
a179a303 211 sha=$(git rev-parse --verify "$rev^{commit}") ||
e3389075 212 die "Bad rev input: $rev"
d3e54c88
CC
213 eval="$eval bisect_write '$state' '$sha'; "
214 done
c9c4e2d5
CC
215 eval "$eval"
216 check_expected_revs "$@" ;;
e3389075
CC
217 *,bad)
218 die "'git bisect bad' can take only one argument." ;;
cc9f24d0
JH
219 *)
220 usage ;;
8cc6a083 221 esac
97e1c51e
CC
222 bisect_auto_next
223}
224
8cc6a083 225bisect_next_check() {
0a5280a9
JH
226 missing_good= missing_bad=
227 git show-ref -q --verify refs/bisect/bad || missing_bad=t
228 test -n "$(git for-each-ref "refs/bisect/good-*")" || missing_good=t
6fecf191 229
0a5280a9
JH
230 case "$missing_good,$missing_bad,$1" in
231 ,,*)
232 : have both good and bad - ok
233 ;;
234 *,)
235 # do not have both but not asked to fail - just report.
236 false
237 ;;
238 t,,good)
239 # have bad but not good. we could bisect although
240 # this is less optimum.
241 echo >&2 'Warning: bisecting only with a bad commit.'
242 if test -t 0
243 then
244 printf >&2 'Are you sure [Y/n]? '
e5d3afd7
FM
245 read yesno
246 case "$yesno" in [Nn]*) exit 1 ;; esac
0a5280a9
JH
247 fi
248 : bisect without good...
249 ;;
8cc6a083 250 *)
0a5280a9 251 THEN=''
823ea121 252 test -s "$GIT_DIR/BISECT_START" || {
0a5280a9
JH
253 echo >&2 'You need to start by "git bisect start".'
254 THEN='then '
255 }
256 echo >&2 'You '$THEN'need to give me at least one good' \
257 'and one bad revisions.'
258 echo >&2 '(You can use "git bisect bad" and' \
259 '"git bisect good" for that.)'
260 exit 1 ;;
8cc6a083
LT
261 esac
262}
263
264bisect_auto_next() {
434d036f 265 bisect_next_check && bisect_next || :
8cc6a083
LT
266}
267
268bisect_next() {
8fe26f44 269 case "$#" in 0) ;; *) usage ;; esac
8cc6a083 270 bisect_autostart
0a5280a9
JH
271 bisect_next_check good
272
0871984d
CC
273 # Perform all bisection computation, display and checkout
274 git bisect--helper --next-all
5a1d31c7 275 res=$?
0a5280a9 276
5a1d31c7
CC
277 # Check if we should exit because bisection is finished
278 test $res -eq 10 && exit 0
0a5280a9 279
5a1d31c7
CC
280 # Check for an error in the bisection process
281 test $res -ne 0 && exit $res
282
283 return 0
8cc6a083
LT
284}
285
cc9f24d0
JH
286bisect_visualize() {
287 bisect_next_check fail
235997c9
JH
288
289 if test $# = 0
290 then
22b3ddd5 291 case "${DISPLAY+set}${SESSIONNAME+set}${MSYSTEM+set}${SECURITYSESSIONID+set}" in
235997c9 292 '') set git log ;;
508e84a7 293 set*) set gitk ;;
235997c9
JH
294 esac
295 else
296 case "$1" in
297 git*|tig) ;;
298 -*) set git log "$@" ;;
299 *) set git "$@" ;;
300 esac
301 fi
302
fc13aa3d 303 eval '"$@"' --bisect -- $(cat "$GIT_DIR/BISECT_NAMES")
cc9f24d0
JH
304}
305
8cc6a083 306bisect_reset() {
823ea121 307 test -s "$GIT_DIR/BISECT_START" || {
fce0499f
CC
308 echo "We are not bisecting."
309 return
310 }
8cc6a083 311 case "$#" in
823ea121 312 0) branch=$(cat "$GIT_DIR/BISECT_START") ;;
6b87ce23
AK
313 1) git rev-parse --quiet --verify "$1^{commit}" > /dev/null ||
314 die "'$1' is not a valid commit"
8cc6a083 315 branch="$1" ;;
8fe26f44 316 *)
8cc6a083
LT
317 usage ;;
318 esac
f3a186ff 319 git checkout "$branch" -- && bisect_clean_state
e204de28
JH
320}
321
38a47fd6 322bisect_clean_state() {
947a604b 323 # There may be some refs packed during bisection.
634f2464 324 git for-each-ref --format='%(refname) %(objectname)' refs/bisect/\* |
947a604b
CC
325 while read ref hash
326 do
823ea121 327 git update-ref -d $ref $hash || exit
947a604b 328 done
c9c4e2d5
CC
329 rm -f "$GIT_DIR/BISECT_EXPECTED_REV" &&
330 rm -f "$GIT_DIR/BISECT_ANCESTORS_OK" &&
823ea121
CC
331 rm -f "$GIT_DIR/BISECT_LOG" &&
332 rm -f "$GIT_DIR/BISECT_NAMES" &&
333 rm -f "$GIT_DIR/BISECT_RUN" &&
9d0cd91c 334 # Cleanup head-name if it got left by an old version of git-bisect
823ea121
CC
335 rm -f "$GIT_DIR/head-name" &&
336
337 rm -f "$GIT_DIR/BISECT_START"
38a47fd6
CC
338}
339
e204de28 340bisect_replay () {
737c74ee 341 test -r "$1" || die "cannot read $1 for replaying"
e204de28 342 bisect_reset
6c98c054 343 while read git bisect command rev
e204de28 344 do
6c98c054
MV
345 test "$git $bisect" = "git bisect" -o "$git" = "git-bisect" || continue
346 if test "$git" = "git-bisect"; then
347 rev="$command"
348 command="$bisect"
349 fi
e204de28
JH
350 case "$command" in
351 start)
e9a45d75 352 cmd="bisect_start $rev"
737c74ee
CC
353 eval "$cmd" ;;
354 good|bad|skip)
355 bisect_write "$command" "$rev" ;;
e204de28 356 *)
737c74ee 357 die "?? what are you talking about?" ;;
e204de28
JH
358 esac
359 done <"$1"
360 bisect_auto_next
8cc6a083
LT
361}
362
a17c4101 363bisect_run () {
83020120
CC
364 bisect_next_check fail
365
a17c4101
CC
366 while true
367 do
368 echo "running $@"
369 "$@"
370 res=$?
371
372 # Check for really bad run error.
373 if [ $res -lt 0 -o $res -ge 128 ]; then
374 echo >&2 "bisect run failed:"
375 echo >&2 "exit code $res from '$@' is < 0 or >= 128"
376 exit $res
377 fi
378
155fc795 379 # Find current state depending on run success or failure.
71b0251c
CC
380 # A special exit code of 125 means cannot test.
381 if [ $res -eq 125 ]; then
382 state='skip'
383 elif [ $res -gt 0 ]; then
155fc795 384 state='bad'
a17c4101 385 else
155fc795 386 state='good'
a17c4101
CC
387 fi
388
155fc795
CC
389 # We have to use a subshell because "bisect_state" can exit.
390 ( bisect_state $state > "$GIT_DIR/BISECT_RUN" )
a17c4101
CC
391 res=$?
392
393 cat "$GIT_DIR/BISECT_RUN"
394
e1622bfc 395 if sane_grep "first bad commit could be any of" "$GIT_DIR/BISECT_RUN" \
71b0251c
CC
396 > /dev/null; then
397 echo >&2 "bisect run cannot continue any more"
398 exit $res
399 fi
400
a17c4101
CC
401 if [ $res -ne 0 ]; then
402 echo >&2 "bisect run failed:"
155fc795 403 echo >&2 "'bisect_state $state' exited with error code $res"
a17c4101
CC
404 exit $res
405 fi
406
e1622bfc 407 if sane_grep "is the first bad commit" "$GIT_DIR/BISECT_RUN" > /dev/null; then
a17c4101
CC
408 echo "bisect run success"
409 exit 0;
410 fi
411
412 done
413}
414
415
8cc6a083
LT
416case "$#" in
4170)
418 usage ;;
419*)
420 cmd="$1"
421 shift
422 case "$cmd" in
243a60fb
CC
423 help)
424 git bisect -h ;;
8cc6a083
LT
425 start)
426 bisect_start "$@" ;;
ee2314f5 427 bad|good)
155fc795 428 bisect_state "$cmd" "$@" ;;
ee2314f5
CC
429 skip)
430 bisect_skip "$@" ;;
8cc6a083
LT
431 next)
432 # Not sure we want "next" at the UI level anymore.
433 bisect_next "$@" ;;
235997c9 434 visualize|view)
cc9f24d0 435 bisect_visualize "$@" ;;
8cc6a083
LT
436 reset)
437 bisect_reset "$@" ;;
e204de28
JH
438 replay)
439 bisect_replay "$@" ;;
440 log)
441 cat "$GIT_DIR/BISECT_LOG" ;;
a17c4101
CC
442 run)
443 bisect_run "$@" ;;
8cc6a083
LT
444 *)
445 usage ;;
446 esac
447esac